program Mondlibration;
(* ... veranschaulicht die Entstehung der optischen Libration des
Mondes in Lnge und Breite und die der Zeitgleichung *)

uses
  Forms,
  WinTypes,
  Graphics,
  Types,
  Eingabe in 'c:\sources.del\EINGABE.PAS' {EingabeDialog},
  mathe in 'c:\sources.del\mathe.pas',
  FensterGraf in 'c:\sources.del\FensterGraf.pas' {Grundfenster},
  ModulGraf in 'c:\sources.del\ModulGraf.pas',
  Kern2Graf in 'c:\sources.del\Kern2Graf.pas',
  KernGraf in 'c:\sources.del\KernGraf.pas';

{$R *.RES}

const inBitmap = false;
      Infotext = false;
      Startbild = false;
      Fontname = 'Courier';
      Fontsize = 10;
      Fontstyle = 0;

const invertiert = false;                        (* Hintergrund schwarz/weiss *)
      Grad = Pi/180.0;
      a = 1.0; T = 1.0;
      dphi = 1.0*Grad;
                              (* Textdatei, wird bei Programmstart angezeigt: *)
         (* temporre Datei zum Speichern des Monduntergrundes: *)
      TempDatei = 'mond.bmp';
      maxArr = 1000;                (* maxZahl der gespeicherten Mittenkoord. *)

type vArr = array [1..maxArr] of rVektor;

var Mond: boolean;
    (* numerische Exzentrizitt, Bahnparameter, mittlere Anomalie
                                                  der Mondbahn: *)
    ex, p, M,
           (* Neigung der Rotationsachse gegen die Bahnnormale: *)
    i,
    (* wahre Anomalie der Mondposition, bei der das Nordende der
                          Rotationsachse von der Erde wegzeigt: *)
    nu0: real;
           (* ursprngliche Sichtbarkeitsnormale in Mondkoord.: *)
    rNorm0, rNormM: rVektor;
    DM, D_M, Dnu, D_nu,
    Dtr0, Dtr0T, Dtr, DtrT: Matrix;  (* Transformationsmatrizen *)
    exStr, iStr, nu0Str, MStr, nuStr: String;
              (* max. Pixelradius und Position der Mondscheibe: *)
    rE, rp, x0, y0: integer;
    yMax: integer;       (* fr Bildschirmausschnitt "von oben" *)
    yK: integer;                    (* yPixel des Kantenblickes *)
    xBp, yBp: integer;     (* Pixelkoordinaten des Brennpunktes *)
    BildNr, rNr: integer;
                (* Mondmitten zum Zeichnen der "Zeitgleichung": *)
    rArr: ^vArr;
    MondC, SchleifeC: Char;
    Schleife, Einzelschritt, WerteEingelesen: boolean;
                              (* Farbe von Mond, Erde und Bahn: *)
    mFarbe, msFarbe, eFarbe, lFarbe, Verzoegerung, jMax: integer;

    bm: TBitmap;
    Bildname: String;

procedure speichereHintergrund(x1, y1, x2, y2: integer);

   var rs, rd: TRect;

   begin
   bm.Width:=x2-x1+1; bm.Height:=y2-y1+1;
   rs:=Rect(x1, y1, x2, y2);
   rd:=Bounds(0, 0, x2-x1+1, y2-y1+1);
   bm.Canvas.CopyRect(rd, zCanvas, rs);
   end;

procedure zeichneHintergrund(x0, y0: integer);

   begin
   zCanvas.Draw(x0, y0, bm);
   end;

function Winkeldistanz(Laenge1, Breite1,
                       Laenge2, Breite2: real): real;

   begin
   Winkeldistanz:=arccos(sin(Breite1)*sin(Breite2)+
                  cos(Breite1)*cos(Breite2)*cos(Laenge1-Laenge2))
   end;

var Taste: integer;
    Abbruch, Pause: boolean;

var Durchlaeufe: integer = 0;            (* ... zhlt die Schleifendurchlufe *)
{
procedure Information;

   var t: Text;
       s: String;

   begin
   if ParamCount>0 then Exit;
   if not DateiVorhanden(Bildname+'.txt') then Exit;
   Assign(t, Bildname+'.txt');
   setzeTextmodus; Reset(t);
   GotoXY(0,zHoehe);
   while not eof(t) do
      begin
      ReadLn(t, s); WriteLn(s);
      end;
   Close(t)
   end;
}

procedure holeEinstellungen;

   var tx: Text;
       MondC: Char;
       Code: integer;

   begin
   Assign(tx, Paramstr(1)); Reset(tx);
   ReadLn(tx, MondC); Mond:=MondC in ['m','M'];
   if eof(tx)
      then
         begin
         if Mond
            then
               begin (* Parameter der Mondbewegung *)
               exStr:='0.0549'; iStr:='6.8'; nu0Str:='256.3';
               end
            else
               begin (* Parameter der Erdbewegung *)
               exStr:='0.0167'; iStr:='23.5'; nu0Str:='350';
               end;
         SchleifeC:='j';
         end
      else
         begin
         ReadLn(tx, exStr);  if Pos(' ',  exStr)>0 then  exStr:=Copy( exStr, 1, Pos(' ',  exStr)-1);
         ReadLn(tx, iStr);   if Pos(' ',   iStr)>0 then   iStr:=Copy(  iStr, 1, Pos(' ',   iStr)-1);
         ReadLn(tx, nu0Str); if Pos(' ', nu0Str)>0 then nu0Str:=Copy(nu0Str, 1, Pos(' ', nu0Str)-1);
         ReadLn(tx, SchleifeC);
         end;
   wandleStringInReal( exStr,  ex, Code); if Code>0 then Halt;
   wandleStringInReal(  iStr,   i, Code); if Code>0 then Halt;
   wandleStringInReal(nu0Str, nu0, Code); if Code>0 then Halt;
   Close(tx);
   end;

procedure Initialisierung;

   var p: integer;

   begin
   bm:=TBitmap.Create;
   bm.Monochrome:=false;
   WerteEingelesen:=false;
   Bildname:=ParamStr(0);
   p:=Length(Bildname);
   while Bildname[p]<>'\' do Dec(p);
   Delete(Bildname, 1, p); Delete(Bildname, Length(Bildname)-3, 4);
   setzeVGAPalette;
   Information(Programmname+'.txt', Fontname, '17. Februar 2015', schwarz);
   New(rArr);
   if ParamCount>0 then
      begin
      holeEinstellungen; Exit
      end;
   liesChar(' Soll die Bewegung des Mondes (m) oder der Erde '+
            '(e) simuliert werden ? ', MondC);
   if MondC in ['m','M']
      then
         begin (* Parameter der Mondbewegung *)
         Mond:=true;
         exStr:='0.0549'; iStr:='6.8'; nu0Str:='256.3';
         end
      else if MondC in ['e','E'] then
         begin (* Parameter der Erdbewegung *)
         Mond:=false;
         exStr:='0.0167'; iStr:='23.5'; nu0Str:='350';
         end;
   end;

var rRot: rVektor;
    xm, ym: integer;
    AnfangAusgabe: boolean;
    r, sign, xp, yp: integer;
    xB, yB, tl, E, rEM, nu, x, y: real;

procedure Vorbereitung;

   var rm: rVektor; pm: pVektor;
       l0: real;
       Dl0, D_l0, Di, D_i, Dnu0, D_nu0: Matrix;

   begin (* Vorbereitung *)
   rNr:=0;
   i:=i*Grad;
   nu0:=nu0*Grad;
   definiereXDrehung(i, Di); definiereXDrehung(-i, D_i);
   definiereZDrehung(nu0, Dnu0); definiereZDrehung(-nu0, D_nu0);
   definiereRVektor(0.0, -1.0, 0.0, rm);
   dreheRVektor(D_nu0, rm); dreheRVektor(Di, rm);
   berechnePolarK(rm, pm);
   l0:=pm.Laenge;
   definiereZDrehung(l0, Dl0);
   definiereZDrehung(-l0, D_l0);
   multipliziereMatrizen(Di, D_nu0, Dtr0T);
   multipliziereMatrizen(D_l0, Dtr0T, Dtr0T);(* Dtr0T: r0 --> rM*)
   multipliziereMatrizen(D_i, Dl0, Dtr0);
   multipliziereMatrizen(Dnu0, Dtr0, Dtr0);  (* Dtr0: rM --> r0 *)
   definiereRVektor(0.0, -1.0, 0.0, rNormM);
                    (* Sichtbarkeitsnormale in Mondkoordinaten: *)
   dreheRVektor(Dtr0T, rNormM);
   definiereRVektor(0.0, 0.0, 1.0, rRot);
                           (* Rotationsachse in r0-Koordinaten: *)
   dreheRVektor(Dtr0, rRot);
   p:=a*(1.0-ex*ex);                           (* Bahnparameter *)
   farbig:=true;
   setzeVGAPalette;
   setzeGrafikmodus; weiss:=255; lFarbe:=gelb;
   xm:=543; ym:=351;
   xm:=KernGraf.xm; ym:=KernGraf.ym;
   if invertiert then
      begin
      weiss:=0; schwarz:=255; lFarbe:=weiss;
      setzeFuelltyp(255, schwarz, schwarz);
      fuelleRechteck(0, 0, xm, ym);
      end;
   setzeTextHFarbe(schwarz);
   if Mond
      then
         begin (* Parameter der Mondbewegung *)
         mFarbe:=gelb; msFarbe:=braun; eFarbe:=hellblau;
         end
      else
         begin (* Parameter der Erdbewegung *)
         mFarbe:=hellblau; msFarbe:=blau; eFarbe:=gelb;
         end;
   rp:=ym div 2 -100; x0:=xm div 2; y0:=ym div 2-50;
   rE:=(*60*)40;
   yMax:=ym-6*zHoehe-2*rE-40;
   yK:=(yMax+20+ym-6*zHoehe) div 2;
   setzeBildschirmausschnitt(5, xm-5, 35, yMax);
   dimensioniereBildschirm(-1.1*a/(yMax-35)*(xm-10),
                            1.1*a/(yMax-35)*(xm-10), -1.1*a, 1.1*a);
   xBp:=xPlot(a*ex); yBp:=yPlot(0.0);
   AnfangAusgabe:=true;

   r:=rE div 2;
   sign:=1;
   xB:=a*ex; yB:=0.0;                             (* Brennpunkt *)
   tl:=0.0*T; M:=0.0; E:=0.0;             (* Anfangsbedingungen *)
   rEM:=a*(1.0-ex); nu:=0.0;
   x:=xB+rEM*cos(nu); y:=yB+rEM*sin(nu);
   xp:=xPlot(x); yp:=yPlot(y);
   definiereZDrehung(nu, Dnu); definiereZDrehung(-nu, D_nu);
   definiereZDrehung(M, DM); definiereZDrehung(-M, D_M);
   multipliziereMatrizen(Dtr0, DM, Dtr);
   rNorm0:=rNormM;
   dreheRVektor(Dtr, rNorm0);(* ursprngliche Sichtbarkeitsnormale im r0-System! *)
   multipliziereMatrizen(D_nu, Dtr, Dtr);      (* Dtr: rM --> r *)
   multipliziereMatrizen(Dtr0T, Dnu, DtrT);
   multipliziereMatrizen(D_M, DtrT, DtrT);    (* DtrT: r --> rM *)
   Inc(rNr);
   definiereRVektor(0.0, -1.0, 0.0, rArr^[rNr]);
   dreheRVektor(DtrT, rArr^[rNr]);
   Verzoegerung:=128;
   jMax:=4;
   end;

procedure parEingabe; far;
(* Diese Prozedur wird beim Start der Programmaktionen (z.B. mit Ctrl R) genau
einmal aufgerufen. *)

   begin
   if not Grundfenster.active then Exit;
   Initialisierung;
   if (ParamCount=0) or WerteEingelesen then
      begin
      liesReal(' Exzentrizitt (0<=ex<1!) = ', exStr, ex);
      liesReal(' Neigung der Rotationsachse gegen '+
               'die Bahnebene in Grad = ', iStr, i);
      liesReal(' wahre Anomalie, bei der der Nordpol von der Erde'+
               ' fortzeigt, in Grad: ', nu0Str, nu0);
      liesChar(' Soll die "Zeitgleichungsschleife" gezeichnet '+
               'werden (j/n) ? ', SchleifeC);
      end;
   Schleife:=SchleifeC in ['j','J'];
   WerteEingelesen:=true;

   Vorbereitung;
   started:=true; Abbruch:=false; Pause:=false; Einzelschritt:=true;
   Info1Str:=' "p": Pause, "Esc": Abbruch';
   end;

function Keplergl(var E: real): real; far;

   begin
   Keplergl:=M+ex*sin(E)-E;
   end;

function Keplergl1(var E: real): real; far;

   begin
   Keplergl1:=ex*cos(E)-1.0;
   end;

procedure zeichneMond(i, M, nu: real; x0, y0, r: integer);

   var rMitte, rNorm, rRotl: rVektor;
       p: pVektor;
       j: integer;
       rl, phiE, Pos, wd: real;
       Str: String;

   procedure zeichneLaengenkreis(l: real; Farbe: integer);

      var D: Matrix;
          phi: real;
          rVl: rVektor;

      begin
      definiereZDrehung(l*Grad, D);
      multipliziereMatrizen(Dtr, D, D);
      if abs(l)<1.0 then Farbe:=hellrot;
      phi:=0.0*Grad;
      definiererVektor(r*cos(phi), 0.0, r*sin(phi), rVl);
      dreherVektor(D, rVl);
      geheNach(x0+Round(rVl[1]), y0-Round(rVl[3]));
      while phi<=ZweiPi do
         begin
         definiererVektor(r*cos(phi), 0.0, r*sin(phi), rVl);
         dreherVektor(D, rVl);
         if rVl[2]>0.0
            then
               begin
               geheNach(x0+Round(rVl[1]), y0-Round(rVl[3]));
               end
            else zieheLinieNach(x0+Round(rVl[1]),
                                y0-Round(rVl[3]), Farbe);
         phi:=phi+dphi;
         end;
      end; (* zeichneLaengenkreis *)

   procedure zeichneBreitenkreis(b: real; Farbe: integer);

      var phi, sinb, cosb: real;
          rVl: rVektor;

      begin
      if abs(b)<1.0 then Farbe:=hellrot;
      b:=b*Grad; sinb:=sin(b); cosb:=cos(b);
      phi:=0.0*Grad;
      definiererVektor(r*cosb*cos(phi), r*cosb*sin(phi),
                       r*sinb, rVl);
      dreherVektor(Dtr, rVl);
      geheNach(x0+Round(rVl[1]), y0-Round(rVl[3]));
      while phi<=ZweiPi do
         begin
         definiererVektor(r*cosb*cos(phi), r*cosb*sin(phi),
                          r*sinb, rVl);
         dreherVektor(Dtr, rVl);
         if rVl[2]>0.0
            then
               begin
               geheNach(x0+Round(rVl[1]), y0-Round(rVl[3]));
               end
            else zieheLinieNach(x0+Round(rVl[1]),
                                y0-Round(rVl[3]), Farbe);
         phi:=phi+dphi;
         end;
      end; (* zeichneBreitenkreis *)

   procedure zeichneZeitgleichungsschleife;

      var i, sFarbe: integer; rl: rVektor;

      begin
      if Mond then sFarbe:=blau else sFarbe:=gelb;
      rl:=rArr^[1]; dreheRVektor(Dtr, rl);
      multipliziereRVektor(r, rl);
      geheNach(x0+Round(rl[1]), y0-Round(rl[3]));
      for i:=2 to rNr do
         begin
         rl:=rArr^[i]; dreheRVektor(Dtr, rl);
         multipliziereRVektor(r, rl);
         if rl[2]>0.0
            then
               begin
               geheNach(x0+Round(rl[1]), y0-Round(rl[3]));
               end
            else zieheLinieNach(x0+Round(rl[1]),
                                y0-Round(rl[3]), sFarbe);
         end;
      end; (* zeichneZeitgleichungsschleife *)

   begin (* zeichneMond *)
   rRotl:=rRot; dreheRVektor(D_nu, rRotl);(* gedrehte Rot.-Achse*)
   berechnePolarK(rRotl, p);
   Pos:=atn2(rRotl[1], rRotl[3]); (* Positionswinke der Rot.-Achse von Erde aus *)
   if Pos<0.0 then Pos:=Pos+ZweiPi;

   rNorm:=rNormM; dreheRVektor(Dtr, rNorm); (* gedrehte Normale *)
              (* Positionswinkel der Normalen von der Erde aus: *)
   phiE:=atn2(-rNorm[3], -rNorm[1]);
   phiE:=phiE-HPi;    (* Startwinkel der "Sichtbarkeitsellipse" *)
   rl:=Abs(rNorm[2]*r);   (* kleine Halbachse derselben Ellipse *)
   setzeFuelltyp(255, msFarbe, msFarbe);
   fuelleEllipse(x0, y0, Round(r), Round(r));(*ganzer Mond braun*)
   if rNorm[2]<0.0              (* mehr als die Hlfte zu sehen *)
      then
         begin
         zeichneHEllipse(x0, y0, r, Round(rl),
                         255, mFarbe, false, true, phiE/Grad);
         zeichneHEllipse(x0, y0, r, r,
                          255, mFarbe, false, true, phiE/Grad+180);
         end
      else
         begin
         zeichneHEllipse(x0, y0, r, r,
                         255, mFarbe, false, true, phiE/Grad+180);
         zeichneHEllipse(x0, y0, r, Round(rl),
                         255, msFarbe, false, true, phiE/Grad+180);
         end;
                                            (* Koordinatennetz: *)
   setzeZeichenfarbe(grau);
   zeichneKreisbogen(x0, y0, r, 0.0, 360.0);
   for j:=0 to 5 do zeichneLaengenkreis(j*30, grau);
   for j:=-2 to 2 do zeichneBreitenkreis(j*30, grau);
   if Schleife then zeichneZeitgleichungsschleife;
   setzeFuelltyp(255, hellgruen, hellgruen);
   fuelleEllipse(x0, y0, 2, 2);       (* Scheibenmitte hellgrn *)
   setzeFuelltyp(255, 0, 0);
   if rNorm[2]<0.0 then          (* ursprngliche Mitte schwarz *)
      fuelleEllipse(x0+Round(rNorm[1]*r),
                    y0-Round(rNorm[3]*r), 2, 2);
   zeichneGrafstring(0, ym-4*zHoehe,
                     '                  mittlere Anomalie ='
                     +MStr+GradC, weiss);
   zeichneGrafstring(0, ym-2*zHoehe,
                     '                     wahre Anomalie ='
                     +nuStr+GradC, weiss);
   wandleZahlInString(Pos/Grad, 3.1, Str);
   zeichneGrafstring(0, ym- 0*zHoehe,
                     ' Positionswinkel der Rotationsachse ='
                     +Str+GradC, weiss);
   definiereRVektor(0.0, -1.0, 0.0, rMitte);
   dreheRVektor(DtrT, rMitte);  (* Mondkoord. der Scheibenmitte *)
   berechnePolarK(rMitte, p);
   wandleZahlInString(p.Laenge/Grad, 3.1, Str);
   zeichneGrafstring(xm div 2+50, ym-4*zHoehe,
                     'Scheibenmitte: L ='+Str+GradC, weiss);
   wandleZahlInString(p.Breite/Grad, 3.1, Str);
   zeichneGrafstring(xm div 2+50, ym-2*zHoehe,
                     '               B ='+Str+GradC, weiss);
   berechnePolarK(rNorm, p);
   wd:=Winkeldistanz(1.5*Pi, 0.0, p.Laenge, p.Breite);
   wandleZahlInString(wd/Grad, 3.1, Str);
   zeichneGrafstring(xm div 2+50, ym-0*zHoehe,
                     'Gesamtlibration  ='+Str+GradC, weiss);
   zeichneGrafstring(0, zHoehe, 'beliebige Taste drcken '+
                     '("s": Bild speichern) ! ', weiss);
   end; (* zeichneMond *)

var Tastel: integer;
    xl, yl, rM: real;

procedure VorbereitungAusgabe;

   begin
   wandleZahlInString(M/Grad, 3.1, MStr);
   wandleZahlInString(nu/Grad, 3.1, nuStr);
   loescheBildschirm;
setzeFuelltyp(255, schwarz, schwarz); fuelleRechteck(0, 0, xm, ym);
   if invertiert then
      begin
      setzeFuelltyp(255, schwarz, schwarz);
      fuelleRechteck(0, 0, xm, ym);
      end;
   zeichneGrafstring(0, 1*zHoehe,
    'Taste drcken ("-","+": rckwrts/vorwrts, "^","v": schneller/langsamer, "z": Mond zeichnen,', weiss);
   zeichneGrafstring(0, 2*zHoehe,
(*    '               "l": mittl. und wahre Anomalie, '+*)
    '               "PgUp","PgDown": Vergrerung/Verkleinerung der Schrittweite, "s":  Bild speichern, '+
    '"Esc": Abbruch, sonst: weiter)', weiss);
   zeichneLinie(0, yMax+20, xm, yMax+20, weiss);
   zeichneLinie(0, ym-6*zHoehe, xm, ym-6*zHoehe, weiss);
   zeichneGrafstring(0, yMax+20-5, ' Blick von Norden', weiss);
   zeichneGrafstring(0, yMax+20+5+zHoehe,
                     ' Blick von der Kante', weiss);
(*   zeichneErde(xBp, yBp);
   zeichneklMond(msFarbe);*)
   zeichneLinie(xBp, yBp, xp, yp, weiss);
   zeichneGrafstring(0, ym-4*zHoehe,
                     '                  mittlere Anomalie ='
                     +MStr+GradC, weiss);
   zeichneGrafstring(0, ym-2*zHoehe,
                     '                     wahre Anomalie ='
                     +nuStr+GradC, weiss);
(*   Taste:=0; Tastel:=0;*)
                                      (* Aufheben der Vorwerte: *)
   xl:=x; yl:=y;
   geheNach(xp, yp);
   AnfangAusgabe:=false;
   end;

procedure zeichneMondphase(rv: rVektor; x0, y0, r, f, hf: integer);
(* Die Routine ist fr den Fall geschrieben worden, dass die x-Achse nach rechts
zeigt, die y-Achse nach hinten! *)

   var Phase, Limbus: real;
       rp: rVektor;

   begin
   r:=r-1;                            (* sonst klappt das Lschen nicht ganz! *)
   setzeFuelltyp(255, hf, hf);
   fuelleEllipse(x0, y0, r, r);
   normiereRVektor(rv);
   definiereRVektor(rv[2], -rv[1], rv[3], rv); (* wegen der ungew. Achsenorientierung *)
   definiereRVektor(rv[1], 0.0, rv[3], rp);
   Limbus:=atn2(rp[3], rp[1])/Grad;
   Phase:=atn2(rv[2], rp[0]);
   zeichneHEllipse(x0, y0, r, r, 255, f, false, true, -90.0+Limbus);
   if Phase>0
      then zeichneHEllipse(x0, y0, r, Round(r*sin( Phase)), 255,      hf, false, true, -90.0+Limbus)
      else zeichneHEllipse(x0, y0, r, Round(r*sin(-Phase)), 255,       f, false, true,  90.0+Limbus)
   end;

var xpMo, ypMo: integer;

procedure Ausgabe;

   const delta = 0.001*T;

   var j: integer;

   procedure zeichneErde(xp, yp: integer);

      begin
      setzeFuelltyp(255, eFarbe, eFarbe);
      fuelleEllipse(xp, yp, rE, rE);
      end;

   procedure zeichneklMond(Farbe: integer);

      var xp, yp, ys: integer;

      procedure zeichneMondVonKante(xp, yp: integer);

         var lFarbe: integer;

         begin
         if Farbe=schwarz then lFarbe:=schwarz else lFarbe:=weiss;
         if nu>=0.0               (* Mond evtl. hinter der Erde *)
            then
               begin
               setzeFuelltyp(255, Farbe, Farbe);
               if rRot[1]<0.0
                  then
                     zeichneLinie(xp+Round(r*rRot[2]),
                                  yp-Round(r*rRot[3]),
                                  xp+Round(2*r*rRot[2]),
                                  yp-Round(2*r*rRot[3]), lFarbe)
                  else
                     zeichneLinie(xp-Round(r*rRot[2]),
                                  yp+Round(r*rRot[3]),
                                  xp-Round(2*r*rRot[2]),
                                  yp+Round(2*r*rRot[3]), lFarbe);
               if Farbe=schwarz
                  then fuelleEllipse(xp, yp, r, r)
                  else zeichneMondphase(rNorm0, xp, yp, r, mFarbe, Farbe);
               if rRot[1]<0.0(* Nordpol von vorn nicht zu sehen *)
                  then
                     zeichneLinie(xp-Round(r*rRot[2]),
                                  yp+Round(r*rRot[3]),
                                  xp-Round(2*r*rRot[2]),
                                  yp+Round(2*r*rRot[3]), lFarbe)
                  else
                     zeichneLinie(xp+Round(r*rRot[2]),
                                  yp-Round(r*rRot[3]),
                                  xp+Round(2*r*rRot[2]),
                                  yp-Round(2*r*rRot[3]), lFarbe);
               zeichneErde(xBp, yK);
               end
            else
               begin
               zeichneErde(xBp, yK);
               setzeFuelltyp(255, Farbe, Farbe);
               if rRot[1]<0.0(* Nordpol von vorn nicht zu sehen *)
                  then
                     zeichneLinie(xp+Round(r*rRot[2]),
                                  yp-Round(r*rRot[3]),
                                  xp+Round(r*rRot[2]),
                                  yp-Round(2*r*rRot[3]), lFarbe)
                  else
                     zeichneLinie(xp-Round(r*rRot[2]),
                                  yp+Round(r*rRot[3]),
                                  xp-Round(2*r*rRot[2]),
                                  yp+Round(2*r*rRot[3]), lFarbe);
               if Farbe=schwarz
                  then fuelleEllipse(xPlot(x), yK, r, r)
                  else zeichneMondphase(rNorm0, xPlot(x), yK, r, mFarbe, Farbe);
               if rRot[1]<0.0(* Nordpol von vorn nicht zu sehen *)
                  then
                     zeichneLinie(xp-Round(r*rRot[2]),
                                  yp+Round(r*rRot[3]),
                                  xp-Round(2*r*rRot[2]),
                                  yp+Round(2*r*rRot[3]), lFarbe)
                  else
                     zeichneLinie(xp+Round(r*rRot[2]),
                                  yp-Round(r*rRot[3]),
                                  xp+Round(2*r*rRot[2]),
                                  yp-Round(2*r*rRot[3]), lFarbe);
               end;
         end; (* zeichneMondVonKante *)

      procedure zeichneMondVonOben(xp, yp: integer);

         begin
         setzeFuelltyp(255, Farbe, Farbe);
         if rRot[3]>0.0            (* Nordpol von oben zu sehen *)
            then
               zeichneLinie(xp-Round(r*rRot[2]),
                            yp-Round(r*rRot[1]),
                            xp-Round(2*r*rRot[2]),
                            yp-Round(2*r*rRot[1]), weiss)
            else
               zeichneLinie(xp+Round(r*rRot[2]),
                            yp+Round(r*rRot[1]),
                            xp+Round(2*r*rRot[2]),
                            yp+Round(2*r*rRot[1]), weiss);
(*         fuelleEllipse(xp, yp, r, r);*)
                 (* Veranschaulichung der Mondrotation durch M: *)
         zeichneHEllipse(xp, yp, r, r,
                         255, msFarbe, false, true, M/Grad-90);
         zeichneHEllipse(xp, yp, r, r,
                         255, mFarbe, false, true, M/Grad+90);
         if rRot[3]>0.0            (* Nordpol von oben zu sehen *)
            then
               zeichneLinie(xp+Round(r*rRot[2]),
                            yp+Round(r*rRot[1]),
                            xp+Round(2*r*rRot[2]),
                            yp+Round(2*r*rRot[1]), weiss)
            else
               zeichneLinie(xp-Round(r*rRot[2]),
                            yp-Round(r*rRot[1]),
                            xp-Round(2*r*rRot[2]),
                            yp-Round(2*r*rRot[1]), weiss);
         end; (* zeichneMondVonOben *)

      begin (* zeichneklMond *)
      xp:=xPlot(x); yp:=yPlot(y);
      ys:=yp-rE-1; if ys<0 then ys:=0;
      if Farbe<>schwarz then
         speichereHintergrund(xp-rE-1, ys, xp+rE, yp+rE);
      zeichneMondVonOben(xp, yp);
      zeichneMondVonKante(xp, yK);
      if Farbe=schwarz then
         zeichneHintergrund(xp-rE-1, ys);
      end;

   begin (* Ausgabe *)
   if AnfangAusgabe then
      begin
      VorbereitungAusgabe;
      zeichneErde(xBp, yBp);
      zeichneklMond(msFarbe);
      rEM:=p/(1.0+ex);
      rM:=a*(1.0-ex)/rEM*rp;
      exit;
      end;
   warte(Verzoegerung);
   for j:=1 to jMax do
      begin
       (* Lschen des Mondes und der Verbindungslinie: *)
      if j=1 then
         begin
         zeichneklMond(schwarz);
         zeichneLinie(xBp, yBp, xp, yp, schwarz);
         end;
      tl:=tl+sign*delta;              (* neue Position *)
      M:=2.0*Pi/T*tl;
      E:=Nullstelle(KeplerGl, KeplerGl1, E, 0.001*Grad,
                    1000);
      nu:=2.0*arctan(sqrt((1.0+ex)/(1.0-ex))*tan(0.5*E));
      rEM:=p/(1.0+ex*cos(nu));
      xl:=x; yl:=y;
      x:=xB+rEM*cos(nu); y:=yB+rEM*sin(nu);
      xp:=xPlot(x); yp:=yPlot(y);
xpMo:=xp; ypMo:=yp;
      zeichneLinie(xPlot(xl), yPlot(yl), xp, yp, lFarbe);
      if j=jMax then
         begin
         zeichneErde(xBp, yBp);
         zeichneklMond(msFarbe);
         zeichneLinie(xBp, yBp, xp, yp, weiss);
         end;
      rM:=a*(1.0-ex)/rEM*rp;
      end;
       (* Berechnung der Mondkoord. der Scheibenmitte: *)
   definiereZDrehung(nu, Dnu);
   definiereZDrehung(-nu, D_nu);
   definiereZDrehung(M, DM);
   definiereZDrehung(-M, D_M);
   multipliziereMatrizen(Dtr0, DM, Dtr);
   rNorm0:=rNormM;
   dreheRVektor(Dtr, rNorm0);(* ursprngliche Sichtbarkeitsnormale im r0-System! *)
                                      (* Dtr: rM --> r *)
   multipliziereMatrizen(D_nu, Dtr, Dtr);
   multipliziereMatrizen(Dtr0T, Dnu, DtrT);
                                     (* DtrT: r --> rM *)
   multipliziereMatrizen(D_M, DtrT, DtrT);
   if rNr<maxArr then Inc(rNr);
   definiereRVektor(0.0, -1.0, 0.0, rArr^[rNr]);
   dreheRVektor(DtrT, rArr^[rNr]);
   wandleZahlInString(M/Grad, 3.1, MStr);
   wandleZahlInString(nu/Grad, 3.1, nuStr);
   zeichneGrafstring(37*zBreite, ym-4*zHoehe,
                     nuStr+GradC, weiss);
   zeichneGrafstring(37*zBreite, ym-2*zHoehe,
                     MStr+GradC, weiss);
   end; (* Ausgabe *)

procedure Pausenanfangprozedur;

   begin
   Info1Str:='Pausenanfang';
   Pause:=true;
   end;

procedure Pausenendeprozedur;

   begin
   Info1Str:=' "p": Pause, "Esc": Abbruch';
   Pause:=false
   end;

var MondGezeichnet: boolean;

procedure Endlosschleife; far;

   var NrStr: String;

   begin
   if not started or Abbruch then Start;
   if Abbruch or not started then Exit;
   if TasteGedrueckt then
      if Pause then
         begin
         Pausenendeprozedur; Taste:=Tastencode;
         end;
   if Pause then Exit;
   if not AnfangAusgabe or Mondgezeichnet then
      if (Einzelschritt or MondGezeichnet) and not TasteGedrueckt then Exit;
   Taste:=Tastencode;
   MondGezeichnet:=false;
   case Taste of
      Esc: begin
           Abbruch:=true;
           AnfangAusgabe:=true;
           loescheBildschirm;
           Info1Str:='Abbruch';
           end;
      Ord('p'): Pausenanfangprozedur;
      Ord('-'): sign:=-sign;
      Ord('+'): sign:=1;
      CursorHoch: if Verzoegerung>2 then Verzoegerung:=Verzoegerung div 2;
      CursorRunter: Verzoegerung:=2*Verzoegerung;
      Ord('e'): Einzelschritt:=not Einzelschritt;
      BildHoch: jMax:=jMax*2;
      BildRunter: if jMax>2 then jMax:=jMax div 2;
      Ord('s'): begin
                Str(BildNr, NrStr);
                speichereBMP(Bildname+NrStr+'.bmp', 0, 0, xm, ym);
                Inc(BildNr)
                end;
      Ord('z'): begin
                AnfangAusgabe:=true;
(*                loescheBildschirm;*)
                   setzeFuelltyp(255, schwarz, schwarz);
(*                   fuelleRechteck(0, 0, xm, ym);*)
(*                   fuelleRechteck(x0-rp div 3-3, y0-rp div -3, rp div 3+6, rp div 3+6);*)
                if invertiert then
                   begin
                   setzeFuelltyp(255, schwarz, schwarz);
 (*                  fuelleRechteck(0, 0, xm, ym);*)
(*                   fuelleRechteck(x0-rp div 3-3, y0-rp div 3-3, rp div 3+6, rp div 3+6);*)
                   end;
                setzeZeichenfarbe(rot);
(*                zeichneKreisbogen(x0, y0, rp, 0, 360);
                zeichneMond(i, M, nu, x0, y0, Round(rM));*)
                zeichneKreisbogen(xpMo, ypMo, rp div 3, 0, 360);
                zeichneMond(i, M, nu, xpMo, ypMo, Round(rM/3));
                Pause:=false;
                MondGezeichnet:=true;
                end;
      end;
   if not Abbruch and (Taste<>Ord('z')) then Ausgabe;
   Taste:=0;
   end;

begin (* Hauptprogramm *)
MondC:='m'; SchleifeC:='j'; BildNr:=1;
exStr:='0.5'; iStr:='45'; nu0Str:='0';
Application.CreateForm(TGrundfenster, Grundfenster);
  Application.CreateForm(TEingabeDialog, EingabeDialog);
  initProgram(inBitmap, Infotext, Startbild, Fontname, Fontsize, Fontstyle);

start:=parEingabe;
run:=Endlosschleife;

Application.Run;                                (* Start der Programmschleife *)
end.
